<html>
<head>
 <title>httpDNS</title>
 <meta name="author" content="Tiger">
 <meta name="copyright" content="Copyright (C) 2006-2008 Tiger">
 <meta name="license" content="General Public License Version 2, June 1991">
</head>
<body>
<?php
  $httpdns_version = "1.2.0";

  $fileio = new FileObject;
  $mysql = new MySQLObject;
  $crypt = new Cryption;

  class dnsrecord
    {
    var $ip;
    var $hostname;
    var $timestamp;

    function dnsrecord()
      {
      $this->ip = "";
      $this->hostname = "";
      $this->timestamp = "";
      }
    }

  class MySQLObject
    {
    var $dblink;
    var $dnstable = array();
    var $logtable = array();

    function MySQLObject()
      {
      $this->dblink = False;
      $this->dnstable = array('mysqlname' => '//config_mysql_dnstable//',
                              'fields' => array('timestamp' => array('size' => 14, 'mysqlname' => 'tstamp', 'mysqltype' => 'varchar'),
                                                'hostname' => array('size' => 25, 'mysqlname' => 'host', 'mysqltype' => 'varchar'),
                                                'ip' => array('size' => 15, 'mysqlname' => 'ip', 'mysqltype' => 'varchar')));
      $this->logtable = array('mysqlname' => '//config_mysql_logtable//',
                              'fields' => array('timestamp' => array('size' => 19, 'mysqlname' => 'tstamp', 'mysqltype' => 'varchar'),
                                                'user' => array('size' => 25, 'mysqlname' => 'user', 'mysqltype' => 'varchar'),
                                                'event' => array('size' => 50, 'mysqlname' => 'event', 'mysqltype' => 'varchar')));
      $this->login("//config_mysql_server//", "//config_mysql_username//", "//config_mysql_password//", "//config_mysql_database//");
      }

    function log_active()
      {
      return ($this->logtable['mysqlname'] !== "");
      }

    function dns_active()
      {
      return ($this->dnstable['mysqlname'] !== "");
      }

    function login($server, $username, $password, $database)
      {
      $result = False;
      if ($this->log_active() || $this->dns_active())
        {
        if ($server !== "" && $username !== "" && $password !== "" && $database !== "")
          {
          $this->dblink = mysql_connect($server, $username, $password);
          if ($this->dblink)
            $result = mysql_select_db($database, $this->dblink);
          else
            writelog("", "CRITICAL: MySQL login failed (MySQLObject.login)");
          }
        else
          writelog("", "CRITICAL: Missing login data (MySQLObject.login)");
        }
      else
        $result = True;
      return $result;
      }

    function logout()
      {
      if ($this->dblink)
        mysql_close($this->dblink);
      }

    function read_log( & $recordlist)
      {
      $result = False;
      if ($this->log_active())
        {
        if ($this->dblink)
          {
          $sql = "SELECT * FROM ".$this->logtable['mysqlname'];
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            while($row  =  mysql_fetch_assoc($result))
              array_push($recordlist, $row['tstamp']." ".$row['user']." ".$row['event']);
            writelog("", "NOTE: Log table read (MySQLObject.read_log)");
            }
          else
            writelog("", "ERROR: Failed reading log table (MySQLObject.read_log)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function append_log($timestamp, $user, $event)
      {
      $result = False;
      if ($this->log_active())
        {
        if ($this->dblink)
          {
          $sql = "CREATE TABLE IF NOT EXISTS ".$this->logtable['mysqlname']." (";
          foreach($this->logtable['fields'] as $field)
            $sql .= $field['mysqlname']." ".$field['mysqltype']."(".$field['size']."),";
          $sql = substr($sql, 0, -1).")";
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            $sql = "INSERT INTO ".$this->logtable['mysqlname']." VALUES (";
            foreach($this->logtable['fields'] as $field)
              {
              switch ($field['mysqlname'])
                {
                case "tstamp":  $content = $timestamp; break;
                case "user":  $content = $user; break;
                case "event": $content = $event; break;
                default: $content = ""; break;
                }
              $sql .= "'".substr($content, 0, $field['size'])."',";
              }
            $sql = substr($sql, 0, -1).")";
            $result = mysql_query($sql, $this->dblink);
            }
          }
        }
      else
        $result = True;
      return $result;
      }

    function clear_log()
      {
      $result = False;
      if ($this->log_active())
        {
        if ($this->dblink)
          {
          $sql = "DELETE FROM ".$this->logtable['mysqlname'];
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            writelog("", "NOTE: Log table cleared (MySQLObject.clear_log)");
          else
            writelog("", "ERROR: Failed clearing log (MySQLObject.clear_log)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function read_dns( & $recordlist)
      {
      $result = False;
      if ($this->dns_active())
        {
        if ($this->dblink)
          {
          $sql = "SELECT * FROM ".$this->dnstable['mysqlname'];
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            $record = new dnsrecord;
            while($row = mysql_fetch_assoc($result))
              {
              $record->timestamp = $row['tstamp'];
              $record->hostname = $row['host'];
              $record->ip = $row['ip'];
              array_push($recordlist, $record);
              }
            }
          else
            writelog("", "CRITICAL: Failed reading DNS table (MySQLObject.read_dns)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function update_dns($newrecord)
      {
      $result = False;
      if ($this->dns_active())
        {
        if ($this->dblink)
          {
          $sql = "CREATE TABLE IF NOT EXISTS ".$this->dnstable['mysqlname']." (";
          foreach($this->dnstable['fields'] as $field)
            $sql .= $field['mysqlname']." ".$field['mysqltype']."(".$field['size']."),";
          $sql = substr($sql, 0, -1).")";
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            $sql_updt = "UPDATE ".$this->dnstable['mysqlname']." SET ";
            $sql_ins = "INSERT INTO ".$this->dnstable['mysqlname']." VALUES (";
            foreach($this->dnstable['fields'] as $field)
              {
              switch ($field['mysqlname'])
                {
                case "tstamp":  $content = $newrecord->timestamp; break;
                case "host":  $content = $newrecord->hostname; break;
                case "ip":  $content = $newrecord->ip; break;
                default: $content = ""; break;
                }
              $sql_updt .= $field['mysqlname']." = '".substr($content, 0, $field['size'])."',";
              $sql_ins .= "'".substr($content, 0, $field['size'])."',";
              }
            $sql_updt = substr($sql_updt, 0, -1)." WHERE host='".$newrecord->hostname."'";
            $sql_ins = substr($sql_ins, 0, -1).")";
            $result = mysql_query($sql_updt, $this->dblink);
            if ($result && mysql_affected_rows($this->dblink) == 0)
              {
              writelog($newrecord->hostname, "NOTE: New host (MySQLObject.update_dns)");
              $result = mysql_query($sql_ins, $this->dblink);
              }
            if ($result)
              writelog($newrecord->hostname, "NOTE: Synchronization successful (MySQLObject.update_dns)");
            else
              writelog("", "CRITICAL: Cannot write DNS entry (MySQLObject.update_dns)");
            }
          else
            writelog("", "CRITICAL: Cannot access DNS table (MySQLObject.update_dns)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function erase_dns_entry($hostname)
      {
      $result = False;
      if ($this->dns_active())
        {
        if ($this->dblink)
          {
          $sql = "DELETE FROM ".$this->dnstable['mysqlname']." WHERE host='".$hostname."' LIMIT 1";
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            if (mysql_affected_rows($this->dblink) > 0)
              writelog("", "NOTE: Hostname '".$hostname."' erased from DNS table (MySQLObject.erase_dns_entry)");
            else
              {
              writelog("", "WARNING: Hostname '".$hostname."' not found in DNS table (MySQLObject.erase_dns_entry)");
              $result = False;
              }
            }
          else
            writelog("", "CRITICAL: Failed reading DNS table (MySQLObject.erase_dns_entry)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function check_for_zombies($limit)
      {
      $result = False;
      if ($this->dns_active() && $limit > 0)
        {
        if ($this->dblink)
          {
          $sql = "DELETE FROM ".$this->dnstable['mysqlname']." WHERE tstamp<'".$limit."'";
          $result = mysql_query($sql, $this->dblink);
          if ($result)
            {
            $count = mysql_affected_rows($this->dblink);
            if ($count > 0)
              writelog("", "NOTE: Burried ".$count." ".(($count == 1)? "zombie" : "zombies")." (MySQLObject.check_for_zombies)");
            }
          else
            writelog("", "CRITICAL: Failed reading DNS table (MySQLObject.check_for_zombies)");
          }
        }
      else
        $result = True;
      return $result;
      }
    }

  class FileObject
    {
    var $dns_filename;
    var $log_filename;
    var $folders_ready;

    function FileObject()
      {
      $this->folders_ready = False;
      $this->dns_filename = "//config_dnsfilename//";
      $this->log_filename = "//config_logfilename//";
      if ($this->create_folder(dirname($this->dns_filename)) && $this->create_folder(dirname($this->log_filename)))
        $this->folders_ready = True;
      }

    function create_folder($path)
      {
      $result = True;
      $folder = "";
      foreach (split('/', $path) as $subfolder)
        {
        if ($subfolder !== "" && $result)
          if ( ! is_dir($folder.$subfolder))
            $result = mkdir($folder.$subfolder, 0777);
        $folder = $folder.$subfolder."/";
        }
      if ( ! $result)
        writelog("", "CRITICAL: Cannot create folder '".$path."'(FileObject.create_folder)");
      return $result;
      }

    function log_active()
      {
      return ($this->log_filename !== "");
      }

    function dns_active()
      {
      return ($this->dns_filename !== "");
      }

    function append_log($timestamp, $user, $message)
      {
      $result = False;
      if ($this->log_active())
        {
        $logfile = fopen($this->log_filename, "a");
        if ($logfile)
          {
          if (fwrite($logfile, "$timestamp $user $message\n"))
            $result = True;
          fclose($logfile);
          }
        }
      return $result;
      }

    function clear_log()
      {
      $result = False;
      if ($this->log_active())
        {
        if (file_exists($this->log_filename))
          {
          $logfile = fopen($this->log_filename, "w");
          if ($logfile)
            {
            fclose($logfile);
            $result = True;
            writelog("", "NOTE: Log file cleared (FileObject.clear_log)");
            }
          else
            writelog("", "ERROR: Cannot rewrite log file (FileObject.clear_log)");
          }
        else
          writelog("", "ERROR: Log file does not exist (FileObject.clear_log)");
        }
      else
        $result = True;
      return $result;
      }

    function read_log( & $recordlist)
      {
      $result = False;
      if (file_exists($this->log_filename))
        {
        $logfile = fopen($this->log_filename, "r");
        if ($logfile)
          {
          while (! feof($logfile))
            array_push($recordlist, trim(fgets($logfile)));
          fclose($logfile);
          $result = True;
          writelog("", "NOTE: Log file read (FileObject.read_log)");
          }
        else
          writelog("", "ERROR: Cannot read log file (FileObject.read_log)");
        }
      else
        writelog("", "ERROR: Log file does not exist (FileObject.read_log)");
      return $result;
      }

    function read_dns( & $recordlist)
      {
      $result = False;
      if ($this->dns_active())
        {
        if (file_exists($this->dns_filename))
          {
          if (filesize($this->dns_filename) > 0)
            {
            $dnsfile = fopen($this->dns_filename, "r");
            if ($dnsfile)
              {
              $recordlist = unserialize(fread($dnsfile, filesize($this->dns_filename)));
              fclose($dnsfile);
              $result = True;
              }
            else
              writelog("", "CRITICAL: Cannot read DNS file (FileObject.read_dns)");
            }
          else
            writelog("", "WARNING: DNS file is empty (FileObject.read_dns)");
          }
        else
          writelog("", "ERROR: DNS file does not exist (FileObject.read_dns)");
        }
      else
        $result = True;
      return $result;
      }


    function update_dns($newrecord)
      {
      $result = False;
      $recordlist = array();
      if ($this->dns_active())
        {
        $index = 0;
        $match = False;
        if ($this->read_dns($recordlist))
          {
          # lookup old record of hostname
          while ($index < count($recordlist) && ! $match)
            {
            if ($recordlist[$index]->hostname == $newrecord->hostname)
              $match = True;
            else
              $index++;
            }
          }
        else
          writelog("", "WARNING: DNS file is being rewritten (FileObject.update_dns)");
        if ($match)
          $recordlist[$index] = $newrecord;
        else
          $recordlist[] = $newrecord;
        $result = $this->write_dns($recordlist);
        if ($result)
          writelog($newrecord->hostname, "NOTE: Synchronization successful (FileObject.update_dns)");
        }
      else
        $result = True;
      return $result;
      }

    function write_dns($recordlist)
      {
      $result = False;
      if ($this->dns_active())
        {
        $dnsfile = fopen($this->dns_filename, "w");
        if ($dnsfile)
          {
          if (fwrite($dnsfile, serialize($recordlist)))
            $result = True;
          else
            writelog("", "CRITICAL: Cannot write DNS file (FileObject.write_dns)");
          fclose($dnsfile);
          }
        else
          writelog("", "CRITICAL: Cannot open DNS file (FileObject.write_dns)");
        }
      else
        $result = True;
      return $result;
      }

    function erase_dns_entry($hostname)
      {
      $result = False;
      $recordlist = array();
      if ($this->dns_active())
        {
        if ($this->read_dns($recordlist))
          {
          # lookup record of hostname
          $index = 0;
          $match = False;
          while ($index < count($recordlist) && ! $match)
            {
            if ($recordlist[$index]->hostname == $hostname)
              $match = True;
            else
              $index++;
            }
          if ($match)
            {
            array_splice($recordlist, $index, 1);
            $result = $this->write_dns($recordlist);
            if ($result)
              writelog($newrecord->hostname, "NOTE: Hostname '".$hostname."' erased from DNS table (FileObject.erase_dns_entry)");
            }
          else
            writelog("", "WARNING: Hostname '".$hostname."' not found in DNS table (FileObject.erase_dns_entry)");
          }
        }
      else
        $result = True;
      return $result;
      }

    function check_for_zombies($limit)
      {
      $result = False;
      $recordlist = array();
      if ($this->dns_active() && $limit > 0)
        {
        if ($this->read_dns($recordlist))
          {
          $index = 0;
          $count = 0;
          while ($index < count($recordlist))
            {
            if ($recordlist[$index]->timestamp < $limit)
              {
              array_splice($recordlist, $index, 1);
              $count++;
              }
            else
              $index++;
            }
          if ($count > 0)
            {
            $result = $this->write_dns($recordlist);
            if ($result)
              writelog("", "NOTE: Burried ".$count." ".(($count == 1)? "zombie" : "zombies")." (FileObject.check_for_zombies)");
            }
          else
            $result = True;
          }
        }
      else
        $result = True;
      return $result;
      }
    }

  class Cryption
    {
    var $keyreference = array();
    var $serverkey = array();

    function Cryption()
      {
      $this->keyreference = array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','@','.','|','_','!');
      $this->serverkey = array(//config_serverkey//);
      }

    function encrypt($record)
      {
      $encrypted = '';
      if ($record->ip !== "" && $record->hostname !== "" && $record->timestamp !== "")
        {
        $ip = explode(".", $record->ip);
        for ($index = 0; $index < count($ip); $index++)
          $encrypted .= substr("0".dechex($ip[$index]), -2, 2);
        $encrypted .= $record->hostname;
        $encrypted .= $record->timestamp;
        $encrypted .= md5($encrypted."\n");
        $encrypted = strtolower($encrypted);
        for ($index = 0; $index < strlen($encrypted); $index++)
          $encrypted[$index] = $this->serverkey[array_search($encrypted[$index], $this->keyreference)];
        }
      else
        writelog("", "ERROR: Empty record (Cryption.encrypt)");
      return $encrypted;
      }

    function decrypt_validate($decrypted)
      {
      $result = False;
      if (strlen($decrypted) >= 32)
        if (md5(substr($decrypted, 0, strlen($decrypted) - 32)."\n") === substr($decrypted, strlen($decrypted) - 32))
          $result = True;
      return $result;
      }

    function decrypt_split($decrypted)
      {
      $result = new dnsrecord;
      if (strlen($decrypted) > 40)
        {
        for ($index = 0; $index < 4; $index++)
          {
          $result->ip .= hexdec(substr($decrypted, 2 * $index, 2));
          if ($index < 3)
            $result->ip .=".";
          }
        $result->hostname = substr($decrypted, 2 * $index, strlen($decrypted) - 2 * $index - 32);
        $result->timestamp = gmdate('YmdHis');
        }
      return $result;
      }

    function decrypt($encrypted)
      {
      $record = new dnsrecord;
      $magic = "";
      $magiclen = 4;
      if (strlen($encrypted) > 40)
        {
        $decrypted = $encrypted;
        for ($index = 0; $index < strlen($decrypted); $index++)
          $decrypted[$index] = $this->keyreference[array_search($decrypted[$index], $this->serverkey)];
        if ( ! $this->decrypt_validate($decrypted)) // magic command format
          {
          $index = strlen($decrypted) - 32 - $magiclen;
          while ($index < strlen($decrypted))
            if (strpos("@0123456789abcdef", $decrypted[$index]))
              $index++;
            else
              {
              $i = 0;
              while ($i < strlen($magic) && ord($decrypted[$index]) > ord($magic[$i]))
                $i++;
              $magic = substr($magic, 0, $i) . $decrypted[$index] . substr($magic, $i);
              $decrypted = substr($decrypted, 0, $index) . substr($decrypted, $index + 1);
              }
          if (strlen($magic) == $magiclen && $this->decrypt_validate($decrypted))
            $record = $this->decrypt_split($decrypted);
          else
            $magic = "";
          }
        else
          $record = $this->decrypt_split($decrypted);
        }
      else
        writelog("", "ERROR: Empty or invalid crypted string (Cryption.decrypt)");
      return array($record, $magic);
      }
    }

  function writelog($user, $message)
    {
    global $fileio;
    global $mysql;
    if ($message != "")
      {
      switch(substr($message, 0, strpos($message, ":")))
        {
        case "CRITICAL": $loglevel = 1; break;
        case "ERROR":    $loglevel = 3; break;
        case "WARNING":  $loglevel = 5; break;
        case "NOTE":     $loglevel = 9; break;
        default:         $loglevel = 7; break;
        }
      if ($loglevel <= //config_loglevel//)
        {
        if ($user == "")
          $user = "(INTERNAL)";
        $timestamp = date('Y-m-d H:i:s');
        $mysql->append_log($timestamp, $user, $message);
        $fileio->append_log($timestamp, $user, $message);
        }
      }
    }

  function respond($message)
    {
    global $httpdns_version;
    if ($message !== "")
      $message = " : {$message}";
    echo "<strong>httpDNS Server (PHP) Version {$httpdns_version}{$message}</strong><br>\n";
    }

  function report_dns($recordlist)
    {
    global $crypt;
    echo "<code>";
    for ($index = 0; $index < count($recordlist); $index++)
      echo $crypt->encrypt($recordlist[$index])."<br>\n";
    echo "</code>";
    }

  function report_ip($recordlist, $hostname)
    {
    $index = 0;
    while($index < count($recordlist) && $recordlist[$index]->hostname != $hostname)
      $index++;
    if ($recordlist[$index]->hostname == $hostname)
      echo $recordlist[$index]->ip;
    else
      echo "N/A";
    }

  function report_log($recordlist)
    {
    echo "<code>";
    foreach ($recordlist as $line)
      echo $line."<br>\n";
    echo "</code>";
    }

  function get_query_string()
    {
    return $_SERVER['QUERY_STRING'];
    }

  function get_remote_addr()
    {
    return $_SERVER['REMOTE_ADDR'];
    }

  function get_time_limit()
    {
    $result = //config_lifetime// * 60 * 60;
    if ($result > 0)
      $result = gmdate("YmdHis", time() - $result);
    return $result;
    }

  function read_dns( & $recordlist)
    {
    global $fileio;
    global $mysql;
    if ($mysql->dns_active())
      $result = $mysql->read_dns($recordlist);
    else
      $result = $fileio->read_dns($recordlist);
    return $result;
    }

  function update_dns($remote)
    {
    global $fileio;
    global $mysql;
    if ($mysql->dns_active())
      $result = $mysql->update_dns($remote);
    else
      $result = $fileio->update_dns($remote);
    return $result;
    }

  function erase_dns_entry($hostname)
    {
    global $fileio;
    global $mysql;
    if ($mysql->dns_active())
      $result = $mysql->erase_dns_entry($hostname);
    else
      $result = $fileio->erase_dns_entry($hostname);
    return $result;
    }

  function log_active()
    {
    global $fileio;
    global $mysql;
    return $fileio->log_active() || $mysql->log_active();
    }

  function read_log( & $recordlist)
    {
    global $fileio;
    global $mysql;
    if ($mysql->log_active())
      $result = $mysql->read_log($recordlist);
    else
      $result = $fileio->read_log($recordlist);
    return $result;
    }

  function clear_log()
    {
    global $fileio;
    global $mysql;
    if ($mysql->log_active())
      $result = $mysql->clear_log();
    else
      $result = $fileio->clear_log();
    return $result;
    }

  function is_admin($remoteip)
    {
    $result = False;
    $admin = "//config_admin//";
    if ($admin != "")
      {
      $recordlist = array();
      if (read_dns($recordlist))
        {
        $index = 0;
        while($index < count($recordlist) && $recordlist[$index]->hostname != $admin)
          $index++;
        if ($recordlist[$index]->hostname == $admin && $recordlist[$index]->ip == $remoteip)
          $result = True;
        }
      }
    else
      $result = True;
    return $result;
    }

  function parse_query()
    {
    global $crypt;
    parse_str(get_query_string(), $parsed);
    $query = $parsed['query'];
    $remote = new dnsrecord;
    $magic = "";
    $serverpass = "//config_serverpass//";
    $password = $parsed['password'];
    $hostname = $parsed['hostname'];
    if ($password != "")
      {
      if ($password == $serverpass)
        {
        if ($hostname != "")
          {
          $remote->ip = get_remote_addr();
          $remote->hostname = $hostname;
          $remote->timestamp = gmdate('YmdHis');
          if (update_dns($remote))
            {
            respond($remote->ip);
            writelog($remote->hostname, "Password synch with '".$remote->ip."' succeeded.");
            }
          else
            respond("ERROR: Cannot open DNS file or table.");
          }
        else
          {
          respond("ERROR: Missing hostname statement.");
          writelog($remote->ip, "No hostname sent with password.");
          }
        }
      else
        {
        respond("ACCESS DENIED.");
        writelog(get_remote_addr(), "WARNING: Wrong password '".$password."'.");
        }
      }
    else
      if ($query != "")
        {
        list($remote, $magic) = $crypt->decrypt($query);
        if ($remote->ip != "" && $remote->hostname != "")
          {
          switch (strtolower($magic))
            {
            case "nrsv":
              respond("");
              writelog($remote->hostname, "Version request succeeded.");
              break;
            case "glov":
              $recordlist = array();
              if (log_active())
                {
                if (read_log($recordlist))
                  {
                  respond("Viewing Log");
                  report_log($recordlist);
                  writelog($remote->hostname, "Reading log succeeded.");
                  }
                else
                  respond("ERROR: Cannot read log.");
                }
              else
                {
                respond("ERROR: Logging not activated.");
                writelog($remote->hostname, "Reading log failed, logging deactivated.");
                }
              break;
            case "gklo":
              if (is_admin(get_remote_addr()))
                {
                if (log_active())
                  {
                  if (clear_log())
                    {
                    respond("Log Erased.");
                    writelog($remote->hostname, "Clearing log succeeded.");
                    }
                  else
                    respond("ERROR: Cannot rewrite Log.");
                  }
                else
                  {
                  respond("ERROR: Logging not activated.");
                  writelog($remote->hostname, "Clearing log failed, logging deactivated.");
                  }
                }
              else
                {
                respond("ERROR: Unauthorized Administator Command.");
                writelog(get_remote_addr(), "WARNING: Clearing log denied.");
                }
              break;
            case "knsy":
              $remote->ip = get_remote_addr();
            case "lnsy":
              $recordlist = array();
              if (update_dns($remote) && read_dns($recordlist))
                {
                respond("");
                report_dns($recordlist);
                writelog($remote->hostname, "Synch with '".$remote->ip."' succeeded.");
                }
              else
                respond("ERROR: Cannot open DNS file or table.");
              break;
            case "ilst":
              $recordlist = array();
              if (read_dns($recordlist))
                {
                respond("");
                report_dns($recordlist);
                writelog($remote->hostname, "Listing hosts succeeded.");
                }
              else
                respond("ERROR: Cannot open DNS file or table.");
              break;
            case "llop":
              $recordlist = array();
              if (read_dns($recordlist))
                {
                report_ip($recordlist, $remote->hostname);
                writelog(get_remote_addr(), "Polling of '".$remote->hostname."' succeeded.");
                }
              else
                respond("ERROR: Cannot open DNS file or table.");
              break;
            case "ikll":
              if (is_admin(get_remote_addr()))
                {
                if (erase_dns_entry($remote->hostname))
                  {
                  respond("DNS entry erased.");
                  writelog(get_remote_addr(), "Erasing '".$remote->hostname."' succeeded.");
                  }
                else
                  respond("ERROR: Cannot erase DNS entry.");
                }
              else
                {
                respond("ERROR: Unauthorized Administator Command.");
                writelog(get_remote_addr(), "WARNING: Killing host '".$remote->hostname."' denied.");
                }
              break;
            default:
              respond("ERROR: Unrecognized magic.");
              writelog($remote->hostname, "ERROR: Unrecognized magic '".$magic."'.");
            }
          }
        else
          {
          respond("ACCESS DENIED.");
          writelog(get_remote_addr(), "WARNING: Unauthorized request.");
          }
        }
      else
        {
        respond(get_remote_addr());
        writelog(get_remote_addr(), "IP mirrored to source.");
        }
    }

  function init()
    {
    global $fileio;
    global $mysql;
    $result = False;
    if ($fileio->folders_ready)
      {
      if ($mysql->dns_active() || $mysql->log_active())
        {
        if ($mysql->dblink)
          {
          $mysql->check_for_zombies(get_time_limit());
          $result = True;
          }
        else
          respond("ERROR: MySQL login failed.");
        }
      else
        {
        $fileio->check_for_zombies(get_time_limit());
        $result = True;
        }
      }
    else
      respond("ERROR: No access to DNS or log folder.");
  return $result;
  }

  if (init())
    parse_query();
  $mysql->logout();
  ?>
</body>
</html>
